import {
  getOutlookUrl,
  getZoomUrl,
  authorizationCodeReplacementToken,
  sendZoomCode,
  getThirdUserPlatForm
} from "../../api/request";
import "dingtalk-jsapi/entry/mobile";
import openLink from "dingtalk-jsapi/api/biz/util/openLink";
import create from "dd-store";
create.Page({
  data: {
    $data: null,
    url: "",
    platform: ""
  },
  onLoad(e) {
    this.setData({
      platform: e.platform
    });
    this.webViewContext = dd.createWebViewContext("web-view-1");
    if (e.platform === "outlook") {
      let data = `${getApp().globalData.userid},${dd.corpId}`;
      getOutlookUrl(data).then(res => {
        openLink({
          url: res.data.data
        });
      });
    } else if (e.platform === "zoom") {
      getZoomUrl("").then(res => {
        this.setData({
          url: res.data.data
        });
      });
    }
  },
  onShow() {
    const interval = setInterval(() => {
      getThirdUserPlatForm().then(res => {
        let relatedAppPlatformList = [];
        res.data.data.forEach(item => {
          if (item.platform === this.data.platform) {
            clearInterval(interval);
            this.$store.data.relatedAppNeedUpdate = {
              name: item.userName,
              platform: this.data.platform
            };
            this.update();
            dd.navigateBack({
              delta: 1
            });
          }
        });
      });
    }, 1000);
  },
  test(e) {
    const code = e.detail.code;
    const state = e.detail.state;
    if (this.data.platform === "outlook") {
      const data = {
        code: code,
        state: state
      };
      authorizationCodeReplacementToken(data).then(res => {
        if (res.data.data) {
          this.$store.data.relatedAppNeedUpdate = {
            name: res.data.data,
            platform: this.data.platform
          };
          this.update();
          dd.navigateBack({
            delta: 1
          });
        }
      });
    } else if (this.data.platform === "zoom") {
      const data = {
        code: code,
        userId: getApp().globalData.userid,
        orgId: dd.corpId
      };
      sendZoomCode(data).then(res => {
        if (res.data.data) {
          this.$store.data.relatedAppNeedUpdate = {
            name: res.data.data,
            platform: this.data.platform
          };
          this.update();
          dd.navigateBack({
            delta: 1
          });
        }
      });
    }
  }
});
